//
//  CFPaymentFormbuilder.swift
//  CFWebSDK-iOS
//
//  Created by Arjun Seshadhry on 29/08/19.
//  Copyright © 2019 CashFree. All rights reserved.
//

import Foundation

class CFPaymentFormBuilder {
    func createForm(stage: String, appId: String, inputParams: Dictionary<String, Any>) -> String {
        var secureURL = ""
        
        switch stage {
        case "PROD":
            secureURL = "https://www.cashfree.com/checkout/post/submit"
        default:
            secureURL = "https://test.cashfree.com/billpay/checkout/post/submit"
        }
        var paymentInputFormHtml =
            "<html>"
                + "<body onload=\'document.order.submit()\'>"
                    + "<form name=\'order\' action=\'\(secureURL)\' method=\'post\'>"
                        + "<input type=\'hidden\' name=\'appId\' value=\'\(appId)\'>"
                        inputParams.keys.forEach { (key) in
                            paymentInputFormHtml += checkAndAdd(inputParams: inputParams, key:  key)
                        }
                        paymentInputFormHtml += "<input type=\'hidden\' name=\'source\' value=\'custom-mob-sdk\'/>" +
                            "<input type=\'hidden\' name=\'hideHeader\' value=\'1\'/>" +
                    "</form>"
                + "</body>"
            + "</html>";
        print(paymentInputFormHtml)
        return paymentInputFormHtml
    }
    
    private func checkAndAdd(inputParams: Dictionary<String, Any>, key: String) -> String {
        
        if let keyVar = inputParams[key] as? String {
            return "<input type=\'hidden\' name=\'\(key)\' value=\'\(keyVar)\'/>"
        } else {
            return ""
        }
    }
    
    
}
