import Flutter
import UIKit

public class SwiftCashfreePgPlugin: NSObject, FlutterPlugin, ResultDelegate {
    var storyboard : UIStoryboard?
    public func onPaymentCompletion(msg: String) {
        print(msg)
        let data :NSData = msg.data(using: String.Encoding.utf8)! as NSData
         do {
            let result :Dictionary = try JSONSerialization.jsonObject(with: data as Data, options:JSONSerialization.ReadingOptions(rawValue: 0)) as! Dictionary<String, String>
            flutterResult!(result)
         } catch is Any {
            var failureResult : Dictionary<String, String> = Dictionary();
            failureResult["txStatus"] = "FAILED"
            failureResult["txMsg"] = "SDK Internal error"
            flutterResult!(failureResult)
        }
    }
    func convertToDictionary(text: String) -> [String: Any]? {
        if let data = text.data(using: .utf8) {
            do {
                return try JSONSerialization.jsonObject(with: data, options: []) as? [String: Any]
            } catch {
                print(error.localizedDescription)
            }
        }
        return nil
    }

    public static func register(with registrar: FlutterPluginRegistrar) {
        let msr = registrar.messenger()
        let channel = FlutterMethodChannel(name: "cashfree_pg", binaryMessenger: msr)
        let instance = SwiftCashfreePgPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    private var flutterResult:FlutterResult?
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        self.flutterResult = result
        var args = call.arguments as? Dictionary<String, Any>
        DispatchQueue.main.async { [weak self] in
                        let cfViewController = CFViewController(
                            params: args as! Dictionary<String, Any>,
                            appId: args!["appId"] as! String,
                            env: args!["stage"] as! String,
                            callBack: self!)
            ((UIApplication.shared.delegate?.window)!)!.rootViewController?.present(cfViewController, animated: true)
        }
    }
    
}
